;+------------------------------------+
;! [NDRINGAR I UFDDOS F\R ABC80       !
;! ver 860814  Bengt Holgersson       !
;! Hittar ni fler buggar var v{nliga  !
;! att meddela detta till ABC-klubben !
;! och/eller till mig.                !
;! Bengt Holgersson                   !
;! Almbacksgatan 12A                  !
;! 211 54 MALM\                       !
;! Tel: Hem 040/111613                !
;!      Arb 040/74130                 !
;!       Sist {ndrad 86-11-17         !
;!       Bert Holgersson              !
;+------------------------------------+
;
;WAMMANFATTNING AV [NDRINGAR:
;======================================
;BUGG I CLOSE RUTIN FIXAD.
;======================================
;DEFAULT DEVICE FLYTTAT.
DEFDEV  EQU  0FD35H
;======================================
;
;DEVICE DESCRIPTION I RAM OCH
;L[NK I SEKTOR READ/WRITE FLYTTADE.
;
DEVDES  EQU  0FFC0H
RDWRET  EQU  0FFE0H
;
;Detta {r gjort f|r att man skall ha
;kvar de f|rsta 64 bytes av POKE-arean
;p} adress 65408.
;
;======================================
;
;BUGGAR I RANDOM ACCESS RUTINER FIXADE
;Parameter i RA-read/write ignorerades
;Fel vid random access av filer med mer
;{n ett segment.
;
TEMPWD  EQU  0FD1AH
;
;Doset skrev |ver pekaren till BASICens
;filbeskrivning.
;
;======================================
;
; DR_: offset i doset:s enhetstabell
; S{tt DROFF att motsvara den typ av
; diskdrives som du har i ditt system
;
HDOFF   EQU  4           ;Winchester
MFOFF   EQU  8           ;ABC832
MOOFF   EQU  12          ;ABC830
SFOFF   EQU  16          ;ABC838
DROFF   EQU  MFOFF       ;DR_: = MF_:
;
;======================================
;
;Hexfilen skall b|rja p} adress 6000H
     ORG 6000H
        DEFB 0C3H
;
;H{r kommer {ndringarna
     ORG 606BH
        DEFW DEVDES
     ORG 6071H
        DEFW RDWRET
     ORG 60DBH
        CALL RDWRET
     ORG 61D0H
        LD   HL,DEVDES
     ORG 62A5H
        LD   (TEMPWD),HL
     ORG 62B0H
        LD   HL,(TEMPWD)
     ORG 6552H
        LD   DE,DEFDEV
     ORG 655DH
        LD   DE,DEVDES
     ORG 656AH
        LD   (DEFDEV),HL
     ORG 6662H
        JP   BLKIN
        JP   BLKUT
     ORG 6681H
        CALL M,23H
;
     ORG 6688H
BLKIN:  XOR  A
BLIN1:  CALL BPOS
        CALL 602DH
        AND  A
        JR   FBFIX
;
BLKUT:  XOR  A
BLUT1:  CALL BPOS
        CALL 6030H
        SCF
FBFIX:  LD   H,(IX+9)
        LD   L,3
        RET  NC
        EX   DE,HL
        LD   A,1
        JR   664AH
;
BPOS:   LD   B,(IX+12)
        AND  A
        RET  Z
        LD   A,D
        AND  E
        INC  A
        RET  Z
        JP   602AH
;
     ORG 6764H
        DEFW DEFDEV
     ORG 678AH
        DEFB DROFF
     ORG 6CF4H
        RET  Z
        NOP
     ORG 6FBFH
        JP   C,BLIN1
        JP   BLUT1
;
;       Patch f|r att DOSGEN skall vara k|rbart
;       Inlagt av Bert Holgersson 86-08-08
;
        ORG   28591
;
        DEFB  44
        DEFB  4
        DEFB  45
        DEFB  4
        DEFB  36
        DEFB  32
        DEFB  37
        DEFB  1
        DEFB  0
;
        END
